mediastreamer2 2.11.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Macros | Functions
Init API - Starting mediastreamer2 library
Mediastreamer2's base APIs

Starting mediastreamer2 library. More...

## Macros
#define | ms_init() ms_base_init(), ms_voip_init(), ms_plugins_init()
#define | ms_exit() ms_voip_exit(), ms_plugins_exit(), ms_base_exit()

## Functions
void | ms_base_init (void)
void | ms_voip_init (void)
void | ms_plugins_init (void)
void | ms_set_plugins_dir (const char *path)
int | ms_load_plugins (const char *directory)
void | ms_base_exit (void)
void | ms_voip_exit (void)
void | ms_plugins_exit (void)
int | ms_get_payload_max_size (void)
int | ms_discover_mtu (const char *destination_host)
void | ms_set_mtu (int mtu)
int | ms_get_mtu (void)
void | ms_set_cpu_count (unsigned int c)
void | ms_sound_device_description_add (const char *manufacturer, const char *model, const char *platform, unsigned int flags, int delay, int recommended_rate)
bool_t | ms_is_ipv6 (const char *address)
bool_t | ms_is_multicast_addr (const struct sockaddr *address)
bool_t | ms_is_multicast (const char *address)
char * | ms_load_file_content (FILE *file, size_t *nbytes)
char * | ms_load_path_content (const char *path, size_t *nbytes)

## Detailed Description

Starting mediastreamer2 library.

## Macro Definition Documentation

#define ms_init | ( |  | ) | ms_base_init(), ms_voip_init(), ms_plugins_init()

Helper macro for backward compatibility. Use ms_base_init() and ms_voip_init() instead.

#define ms_exit | ( |  | ) | ms_voip_exit(), ms_plugins_exit(), ms_base_exit()

Helper macro for backward compatibility. Use ms_base_exit() and ms_voip_exit() instead.

## Function Documentation

void ms_base_init | ( | void |  | ) |

Initialize the mediastreamer2 base library.

This must be called once before calling any other API.

void ms_voip_init | ( | void |  | ) |

Initialize the mediastreamer2 VoIP library.

This must be called one before calling any other API.

void ms_plugins_init | ( | void |  | ) |

Load the plugins from the default plugin directory.

This is just a wrapper around ms_load_plugins(). This must be called after ms_base_init() and after ms_voip_init().

void ms_set_plugins_dir | ( | const char * | path | ) |

Set the directory from where the plugins are to be loaded when calling ms_plugins_init().

Parameters

  [in] | path | The path to the plugins directory.

int ms_load_plugins | ( | const char * | directory | ) |

Load plugins from a specific directory. This method basically loads all libraries in the specified directory and attempts to call a C function called <libraryname>_init. For example if a library 'libdummy.so' or 'libdummy.dll' is found, then the loader tries to locate a C function called 'libdummy_init()' and calls it if it exists. ms_load_plugins() can be used to load non-mediastreamer2 plugins as it does not expect mediastreamer2 specific entry points.

Parameters

  directory | A directory where plugins library are available.

Returns: >0 if successfull, 0 if not plugins loaded, -1 otherwise.

void ms_base_exit | ( | void |  | ) |

Release resource allocated in the mediastreamer2 base library.

This must be called once before closing program.

void ms_voip_exit | ( | void |  | ) |

Release resource allocated in the mediastreamer2 VoIP library.

This must be called once before closing program.

void ms_plugins_exit | ( | void |  | ) |

Unload the plugins loaded by ms_plugins_init().

int ms_get_payload_max_size | ( | void |  | ) |

The max payload size allowed. Filters that generate data that can be sent through RTP should make packets whose size is below ms_get_payload_max_size(). The default value is 1440 computed as the standard internet MTU minus IPv6 header, UDP header and RTP header. As IPV4 header is smaller than IPv6 header, this value works for both.

int ms_discover_mtu | ( | const char * | destination_host | ) |

Returns the network Max Transmission Unit to reach destination_host. This will attempt to send one or more big packets to destination_host, to a random port. Those packets are filled with zeroes.

void ms_set_mtu | ( | int | mtu | ) |

Set mediastreamer default mtu, used to compute the default RTP max payload size. This function will call ms_set_payload_max_size(mtu-[ipv6 header size]).

int ms_get_mtu | ( | void |  | ) |

Get mediastreamer default mtu, used to compute the default RTP max payload size.

void ms_set_cpu_count | ( | unsigned int | c | ) |

Declare how many cpu (cores) are available on the platform

void ms_sound_device_description_add | ( | const char * | manufacturer,
|  | const char * | model,
|  | const char * | platform,
|  | unsigned int | flags,
|  | int | delay,
|  | int | recommended_rate
| ) |  |

Adds a new entry in the SoundDeviceDescription table

bool_t ms_is_ipv6 | ( | const char * | address | ) |

Returns
  TRUE if address is ipv6

bool_t ms_is_multicast_addr | ( | const struct sockaddr * | address | ) |

Returns
  TRUE if address is multicast

bool_t ms_is_multicast | ( | const char * | address | ) |

Returns
  TRUE if address is multicast

char* ms_load_file_content | ( | FILE * | file,
|  | size_t * | nbytes
| ) |  |

Utility function to load a file into memory.

Parameters

  file | a FILE handle
  nbytes | (optional) number of bytes read

char* ms_load_path_content | ( | const char * | path,
|  | size_t * | nbytes
| ) |  |

Utility function to load a file into memory.

Parameters

  path | a FILE handle
  nbytes | (optional) number of bytes read